Index: palm/trunk/SOURCE/pmc_interface_mod.f90
===================================================================
--- palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2798)
+++ palm/trunk/SOURCE/pmc_interface_mod.f90	(revision 2801)
@@ -2882,4 +3002,6 @@
     ELSEIF ( ASSOCIATED( p_2d ) )  THEN
        CALL pmc_s_set_dataarray( child_id, p_2d )
+    ELSEIF ( ASSOCIATED( i_2d ) )  THEN
+       CALL pmc_s_set_dataarray( child_id, i_2d )
     ELSE
 !
@@ -2887,5 +3009,5 @@
        IF ( myid == 0  .AND.  cpl_id == 1 )  THEN
 
-          message_string = 'pointer for array "' // TRIM( name ) //             &
+          message_string = 'pointer for array "' // TRIM( name ) //            &
                            '" can''t be associated'
           CALL message( 'pmci_set_array_pointer', 'PA0117', 3, 2, 0, 6, 0 )
@@ -2911,8 +3033,10 @@
 
     IF ( ASSOCIATED( p_3d ) )  THEN
-       CALL pmc_s_set_dataarray( child_id, p_3d, nz_cl, nz,                     &
+       CALL pmc_s_set_dataarray( child_id, p_3d, nz_cl, nz,                    &
                                  array_2 = p_3d_sec )
     ELSEIF ( ASSOCIATED( p_2d ) )  THEN
        CALL pmc_s_set_dataarray( child_id, p_2d )
+    ELSEIF ( ASSOCIATED( i_2d ) )  THEN
+       CALL pmc_s_set_dataarray( child_id, i_2d )
     ELSE
 !
@@ -2920,5 +3044,5 @@
        IF ( myid == 0  .AND.  cpl_id == 1 )  THEN
 
-          message_string = 'pointer for array "' // TRIM( name ) //             &
+          message_string = 'pointer for array "' // TRIM( name ) //            &
                            '" can''t be associated'
           CALL message( 'pmci_set_array_pointer', 'PA0117', 3, 2, 0, 6, 0 )
@@ -2933,32 +3057,91 @@
 
 #endif
- END SUBROUTINE pmci_set_array_pointer
-
-
-
- SUBROUTINE pmci_create_child_arrays( name, is, ie, js, je, nzc, n )
+END SUBROUTINE pmci_set_array_pointer
+
+INTEGER FUNCTION get_number_of_childs ()
+   IMPLICIT NONE
+
+   get_number_of_childs = SIZE( pmc_parent_for_child ) - 1
+
+   RETURN
+END FUNCTION get_number_of_childs
+
+INTEGER FUNCTION get_childid (id_index)
+   IMPLICIT NONE
+
+   INTEGER,INTENT(IN)                 :: id_index
+
+   get_childid = pmc_parent_for_child(id_index)
+
+   RETURN
+END FUNCTION get_childid
+
+SUBROUTINE  get_child_edges (m, lx_coord, lx_coord_b, rx_coord, rx_coord_b,    &
+                               sy_coord, sy_coord_b, ny_coord, ny_coord_b,     &
+                               uz_coord, uz_coord_b)
+   IMPLICIT NONE
+   INTEGER,INTENT(IN)             ::  m
+   REAL(wp),INTENT(OUT)           ::  lx_coord, lx_coord_b
+   REAL(wp),INTENT(OUT)           ::  rx_coord, rx_coord_b
+   REAL(wp),INTENT(OUT)           ::  sy_coord, sy_coord_b
+   REAL(wp),INTENT(OUT)           ::  ny_coord, ny_coord_b
+   REAL(wp),INTENT(OUT)           ::  uz_coord, uz_coord_b
+
+   lx_coord = childgrid(m)%lx_coord
+   rx_coord = childgrid(m)%rx_coord
+   sy_coord = childgrid(m)%sy_coord
+   ny_coord = childgrid(m)%ny_coord
+   uz_coord = childgrid(m)%uz_coord
+
+   lx_coord_b = childgrid(m)%lx_coord_b
+   rx_coord_b = childgrid(m)%rx_coord_b
+   sy_coord_b = childgrid(m)%sy_coord_b
+   ny_coord_b = childgrid(m)%ny_coord_b
+   uz_coord_b = childgrid(m)%uz_coord_b
+
+END SUBROUTINE get_child_edges
+
+SUBROUTINE  get_child_gridspacing (m, dx,dy,dz)
+
+   IMPLICIT NONE
+   INTEGER,INTENT(IN)             ::  m
+   REAL(wp),INTENT(OUT)           ::  dx,dy
+   REAL(wp),INTENT(OUT),OPTIONAL  ::  dz
+
+   dx = childgrid(m)%dx
+   dy = childgrid(m)%dy
+   IF(PRESENT(dz))   THEN
+      dz = childgrid(m)%dz
+   ENDIF
+
+END SUBROUTINE get_child_gridspacing
+
+SUBROUTINE pmci_create_child_arrays( name, is, ie, js, je, nzc,n  )
 
     IMPLICIT NONE
 
-    CHARACTER(LEN=*), INTENT(IN) ::  name    !:
-
-    INTEGER(iwp), INTENT(IN) ::  ie      !:
-    INTEGER(iwp), INTENT(IN) ::  is      !:
-    INTEGER(iwp), INTENT(IN) ::  je      !:
-    INTEGER(iwp), INTENT(IN) ::  js      !:
-    INTEGER(iwp), INTENT(IN) ::  nzc     !:  Note that nzc is cg%nz
+    CHARACTER(LEN=*), INTENT(IN) ::  name    !<
+
+    INTEGER(iwp), INTENT(IN) ::  ie      !<
+    INTEGER(iwp), INTENT(IN) ::  is      !<
+    INTEGER(iwp), INTENT(IN) ::  je      !<
+    INTEGER(iwp), INTENT(IN) ::  js      !<
+    INTEGER(iwp), INTENT(IN) ::  nzc     !<  Note that nzc is cg%nz
 
     INTEGER(iwp), INTENT(IN), OPTIONAL ::  n  !< number of chemical species
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  ierr    !:
-    INTEGER(iwp) ::  istat   !:
-
-    REAL(wp), POINTER,DIMENSION(:,:)   ::  p_2d    !:
-    REAL(wp), POINTER,DIMENSION(:,:,:) ::  p_3d    !:
+    INTEGER(iwp) ::  ierr    !<
+    INTEGER(iwp) ::  istat   !<
+
+    REAL(wp), POINTER,DIMENSION(:,:)       ::  p_2d    !<
+    REAL(wp), POINTER,DIMENSION(:,:,:)     ::  p_3d    !<
+    INTEGER(idp), POINTER,DIMENSION(:,:)   ::  i_2d    !<
 
 
     NULLIFY( p_3d )
     NULLIFY( p_2d )
+    NULLIFY( i_2d )
+
 !
 !-- List of array names, which can be coupled
@@ -2996,4 +3179,10 @@
        IF ( .NOT. ALLOCATED( sc ) )  ALLOCATE( sc(0:nzc+1,js:je,is:ie) )
        p_3d => sc
+    ELSEIF (trim(name) == "nr_part") then
+       IF (.not.allocated(nr_partc))  allocate(nr_partc(js:je, is:ie))
+       i_2d => nr_partc
+    ELSEIF (trim(name) == "part_adr") then
+       IF (.not.allocated(part_adrc))  allocate(part_adrc(js:je, is:ie))
+       i_2d => part_adrc
     ELSEIF ( TRIM( name(1:5) ) == "chem_" )  THEN
        IF ( .NOT. ALLOCATED( chem_spec_c ) )                                   &
@@ -3009,4 +3198,6 @@
     ELSEIF ( ASSOCIATED( p_2d ) )  THEN
        CALL pmc_c_set_dataarray( p_2d )
+    ELSEIF ( ASSOCIATED( i_2d ) )  THEN
+       CALL pmc_c_set_dataarray( i_2d )
     ELSE
 !
@@ -3014,5 +3205,5 @@
        IF ( myid == 0  .AND.  cpl_id == 2 )  THEN
 
-          message_string = 'pointer for array "' // TRIM( name ) //             &
+          message_string = 'pointer for array "' // TRIM( name ) //            &
                            '" can''t be associated'
           CALL message( 'pmci_create_child_arrays', 'PA0170', 3, 2, 0, 6, 0 )
@@ -3037,8 +3228,8 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  child_id    !:
-    INTEGER(iwp) ::  m           !:
-
-    REAL(wp) ::  waittime        !:
+    INTEGER(iwp) ::  child_id    !<
+    INTEGER(iwp) ::  m           !<
+
+    REAL(wp) ::  waittime        !<
 
 
@@ -3086,15 +3277,15 @@
 !
 !--    The interpolation.
-       CALL pmci_interp_tril_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,    &
+       CALL pmci_interp_tril_all ( u,  uc,  icu, jco, kco, r1xu, r2xu, r1yo,   &
                                    r2yo, r1zo, r2zo, 'u' )
-       CALL pmci_interp_tril_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,    &
+       CALL pmci_interp_tril_all ( v,  vc,  ico, jcv, kco, r1xo, r2xo, r1yv,   &
                                    r2yv, r1zo, r2zo, 'v' )
-       CALL pmci_interp_tril_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,    &
+       CALL pmci_interp_tril_all ( w,  wc,  ico, jco, kcw, r1xo, r2xo, r1yo,   &
                                    r2yo, r1zw, r2zw, 'w' )
-       CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,    &
+       CALL pmci_interp_tril_all ( e,  ec,  ico, jco, kco, r1xo, r2xo, r1yo,   &
                                    r2yo, r1zo, r2zo, 'e' )
 
        IF ( .NOT. neutral )  THEN
-          CALL pmci_interp_tril_all ( pt, ptc, ico, jco, kco, r1xo, r2xo,       &
+          CALL pmci_interp_tril_all ( pt, ptc, ico, jco, kco, r1xo, r2xo,      &
                                       r1yo, r2yo, r1zo, r2zo, 's' )
        ENDIF
@@ -3102,18 +3293,18 @@
        IF ( humidity )  THEN
 
-          CALL pmci_interp_tril_all ( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo,   &
+          CALL pmci_interp_tril_all ( q, q_c, ico, jco, kco, r1xo, r2xo, r1yo, &
                                       r2yo, r1zo, r2zo, 's' )
 
           IF ( cloud_physics  .AND.  microphysics_morrison )  THEN
-             CALL pmci_interp_tril_all ( qc, qcc, ico, jco, kco, r1xo, r2xo,    &
+             CALL pmci_interp_tril_all ( qc, qcc, ico, jco, kco, r1xo, r2xo,   &
                                           r1yo, r2yo, r1zo, r2zo, 's' ) 
-             CALL pmci_interp_tril_all ( nc, ncc, ico, jco, kco, r1xo, r2xo,    &
+             CALL pmci_interp_tril_all ( nc, ncc, ico, jco, kco, r1xo, r2xo,   &
                                          r1yo, r2yo, r1zo, r2zo, 's' )   
           ENDIF
 
           IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
-             CALL pmci_interp_tril_all ( qr, qrc, ico, jco, kco, r1xo, r2xo,    &
+             CALL pmci_interp_tril_all ( qr, qrc, ico, jco, kco, r1xo, r2xo,   &
                                          r1yo, r2yo, r1zo, r2zo, 's' )
-             CALL pmci_interp_tril_all ( nr, nrc, ico, jco, kco, r1xo, r2xo,    &
+             CALL pmci_interp_tril_all ( nr, nrc, ico, jco, kco, r1xo, r2xo,   &
                                          r1yo, r2yo, r1zo, r2zo, 's' )
           ENDIF
@@ -3122,5 +3313,5 @@
 
        IF ( passive_scalar )  THEN
-          CALL pmci_interp_tril_all ( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,   &
+          CALL pmci_interp_tril_all ( s, sc, ico, jco, kco, r1xo, r2xo, r1yo,  &
                                       r2yo, r1zo, r2zo, 's' )
        ENDIF
@@ -3169,5 +3360,5 @@
 
 
-    SUBROUTINE pmci_interp_tril_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,     &
+    SUBROUTINE pmci_interp_tril_all( f, fc, ic, jc, kc, r1x, r2x, r1y, r2y,    &
                                      r1z, r2z, var )
 !
@@ -3177,43 +3368,43 @@
        IMPLICIT NONE
 
-       CHARACTER(LEN=1), INTENT(IN) :: var  !:
-
-       INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)           ::  ic    !:
-       INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc    !:
-       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !:
-
-       INTEGER(iwp) ::  i        !:
-       INTEGER(iwp) ::  ib       !:
-       INTEGER(iwp) ::  ie       !:
-       INTEGER(iwp) ::  j        !:
-       INTEGER(iwp) ::  jb       !:
-       INTEGER(iwp) ::  je       !:
-       INTEGER(iwp) ::  k        !:
-       INTEGER(iwp) ::  k_wall   !:
-       INTEGER(iwp) ::  k1       !:
-       INTEGER(iwp) ::  kbc      !:
-       INTEGER(iwp) ::  l        !:
-       INTEGER(iwp) ::  m        !:
-       INTEGER(iwp) ::  n        !:
-
-       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !:
-       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc       !:
-       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r1x   !:
-       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r2x   !:
-       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r1y   !:
-       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r2y   !:
-       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r1z   !:
-       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r2z   !:
-
-       REAL(wp) ::  fk         !:
-       REAL(wp) ::  fkj        !:
-       REAL(wp) ::  fkjp       !:
-       REAL(wp) ::  fkp        !:
-       REAL(wp) ::  fkpj       !:
-       REAL(wp) ::  fkpjp      !:
-       REAL(wp) ::  logratio   !:
-       REAL(wp) ::  logzuc1    !:
-       REAL(wp) ::  zuc1       !:
-       REAL(wp) ::  z0_topo    !:  roughness at vertical walls
+       CHARACTER(LEN=1), INTENT(IN) :: var  !<
+
+       INTEGER(iwp), DIMENSION(nxlg:nxrg), INTENT(IN)           ::  ic    !<
+       INTEGER(iwp), DIMENSION(nysg:nyng), INTENT(IN)           ::  jc    !<
+       INTEGER(iwp), DIMENSION(nzb:nzt+1), INTENT(IN)           ::  kc    !<
+
+       INTEGER(iwp) ::  i        !<
+       INTEGER(iwp) ::  ib       !<
+       INTEGER(iwp) ::  ie       !<
+       INTEGER(iwp) ::  j        !<
+       INTEGER(iwp) ::  jb       !<
+       INTEGER(iwp) ::  je       !<
+       INTEGER(iwp) ::  k        !<
+       INTEGER(iwp) ::  k_wall   !<
+       INTEGER(iwp) ::  k1       !<
+       INTEGER(iwp) ::  kbc      !<
+       INTEGER(iwp) ::  l        !<
+       INTEGER(iwp) ::  m        !<
+       INTEGER(iwp) ::  n        !<
+
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg), INTENT(INOUT) :: f !<
+       REAL(wp), DIMENSION(0:cg%nz+1,jcs:jcn,icl:icr), INTENT(IN) :: fc       !<
+       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r1x   !<
+       REAL(wp), DIMENSION(nxlg:nxrg), INTENT(IN) :: r2x   !<
+       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r1y   !<
+       REAL(wp), DIMENSION(nysg:nyng), INTENT(IN) :: r2y   !<
+       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r1z   !<
+       REAL(wp), DIMENSION(nzb:nzt+1), INTENT(IN) :: r2z   !<
+
+       REAL(wp) ::  fk         !<
+       REAL(wp) ::  fkj        !<
+       REAL(wp) ::  fkjp       !<
+       REAL(wp) ::  fkp        !<
+       REAL(wp) ::  fkpj       !<
+       REAL(wp) ::  fkpjp      !<
+       REAL(wp) ::  logratio   !<
+       REAL(wp) ::  logzuc1    !<
+       REAL(wp) ::  zuc1       !<
+       REAL(wp) ::  z0_topo    !<  roughness at vertical walls
 
 
@@ -3292,5 +3483,5 @@
                 k = k_wall + 1
                 DO  WHILE ( zu(k) < zuc1 )
-                   logratio = ( LOG( ( zu(k) - zu(k_wall) ) / z0_topo ) ) /     &
+                   logratio = ( LOG( ( zu(k) - zu(k_wall) ) / z0_topo ) ) /    &
                                 logzuc1
                    f(k,j,i) = logratio * f(k1,j,i)
@@ -3331,5 +3522,5 @@
 #if defined( __parallel )
 
-    USE control_parameters,                                                     &
+    USE control_parameters,                                                    &
         ONLY:  dt_restart, end_time, message_string, restart_time, time_restart
 
@@ -3353,9 +3544,9 @@
     IF ( .NOT. pmc_is_rootmodel() )  THEN
        IF ( end_time /= end_time_root )  THEN
-          WRITE( message_string, * )  'mismatch between root model and ',       &
-               'child settings &   end_time(root) = ', end_time_root,           &
-               ' &   end_time(child) = ', end_time, ' & child value is set',    &
+          WRITE( message_string, * )  'mismatch between root model and ',      &
+               'child settings &   end_time(root) = ', end_time_root,          &
+               ' &   end_time(child) = ', end_time, ' & child value is set',   &
                ' to root value'
-          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6,  &
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
                         0 )
           end_time = end_time_root
@@ -3369,9 +3560,9 @@
     IF ( .NOT. pmc_is_rootmodel() )  THEN
        IF ( restart_time /= restart_time_root )  THEN
-          WRITE( message_string, * )  'mismatch between root model and ',       &
-               'child settings &   restart_time(root) = ', restart_time_root,   &
-               ' &   restart_time(child) = ', restart_time, ' & child ',        &
+          WRITE( message_string, * )  'mismatch between root model and ',      &
+               'child settings &   restart_time(root) = ', restart_time_root,  &
+               ' &   restart_time(child) = ', restart_time, ' & child ',       &
                'value is set to root value'
-          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6,  &
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
                         0 )
           restart_time = restart_time_root
@@ -3385,9 +3576,9 @@
     IF ( .NOT. pmc_is_rootmodel() )  THEN
        IF ( dt_restart /= dt_restart_root )  THEN
-          WRITE( message_string, * )  'mismatch between root model and ',       &
-               'child settings &   dt_restart(root) = ', dt_restart_root,       &
-               ' &   dt_restart(child) = ', dt_restart, ' & child ',            &
+          WRITE( message_string, * )  'mismatch between root model and ',      &
+               'child settings &   dt_restart(root) = ', dt_restart_root,      &
+               ' &   dt_restart(child) = ', dt_restart, ' & child ',           &
                'value is set to root value'
-          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6,  &
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
                         0 )
           dt_restart = dt_restart_root
@@ -3401,9 +3592,9 @@
     IF ( .NOT. pmc_is_rootmodel() )  THEN
        IF ( time_restart /= time_restart_root )  THEN
-          WRITE( message_string, * )  'mismatch between root model and ',       &
-               'child settings &   time_restart(root) = ', time_restart_root,   &
-               ' &   time_restart(child) = ', time_restart, ' & child ',        &
+          WRITE( message_string, * )  'mismatch between root model and ',      &
+               'child settings &   time_restart(root) = ', time_restart_root,  &
+               ' &   time_restart(child) = ', time_restart, ' & child ',       &
                'value is set to root value'
-          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6,  &
+          CALL message( 'pmci_check_setting_mismatches', 'PA0419', 0, 1, 0, 6, &
                         0 )
           time_restart = time_restart_root
@@ -3424,13 +3615,13 @@
     IMPLICIT NONE
 
-    INTEGER(iwp) ::  i                           !:
-    INTEGER(iwp) ::  ierr                        !:
-    INTEGER(iwp) ::  j                           !:
-    INTEGER(iwp) ::  k                           !:
-
-    REAL(wp) ::  dxdy                            !:
-    REAL(wp) ::  innor                           !:
-    REAL(wp) ::  w_lt                            !:
-    REAL(wp), DIMENSION(1:3) ::  volume_flow_l   !:
+    INTEGER(iwp) ::  i                           !<
+    INTEGER(iwp) ::  ierr                        !<
+    INTEGER(iwp) ::  j                           !<
+    INTEGER(iwp) ::  k                           !<
+
+    REAL(wp) ::  dxdy                            !<
+    REAL(wp) ::  innor                           !<
+    REAL(wp) ::  w_lt                            !<
+    REAL(wp), DIMENSION(1:3) ::  volume_flow_l   !<
 
 !
@@ -3465,5 +3656,5 @@
 #if defined( __parallel )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(1), volume_flow(1), 1, MPI_REAL,          &
+    CALL MPI_ALLREDUCE( volume_flow_l(1), volume_flow(1), 1, MPI_REAL,         &
                         MPI_SUM, comm2d, ierr )
 #else
@@ -3502,5 +3693,5 @@
 #if defined( __parallel )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(2), volume_flow(2), 1, MPI_REAL,          &
+    CALL MPI_ALLREDUCE( volume_flow_l(2), volume_flow(2), 1, MPI_REAL,         &
                         MPI_SUM, comm2d, ierr )
 #else
@@ -3522,5 +3713,5 @@
 #if defined( __parallel )
     IF ( collective_wait )  CALL MPI_BARRIER( comm2d, ierr )
-    CALL MPI_ALLREDUCE( volume_flow_l(3), volume_flow(3), 1, MPI_REAL,          &
+    CALL MPI_ALLREDUCE( volume_flow_l(3), volume_flow(3), 1, MPI_REAL,         &
                         MPI_SUM, comm2d, ierr )
 #else
@@ -3553,7 +3744,7 @@
    IMPLICIT NONE
 
-   INTEGER(iwp)           :: ierr  !:
-   REAL(wp), DIMENSION(1) :: dtl   !:
-   REAL(wp), DIMENSION(1) :: dtg   !:
+   INTEGER(iwp)           :: ierr  !<
+   REAL(wp), DIMENSION(1) :: dtl   !<
+   REAL(wp), DIMENSION(1) :: dtg   !<
 
    
@@ -3575,9 +3766,9 @@
     IMPLICIT NONE
 
-    INTEGER(iwp), INTENT(IN) ::  swaplevel  !: swaplevel (1 or 2) of PALM's
-                                            !: timestep
-
-    INTEGER(iwp)            ::  child_id    !:
-    INTEGER(iwp)            ::  m           !:
+    INTEGER(iwp), INTENT(IN) ::  swaplevel  !< swaplevel (1 or 2) of PALM's
+                                            !< timestep
+
+    INTEGER(iwp)            ::  child_id    !<
+    INTEGER(iwp)            ::  m           !<
 
 #if defined( __parallel )
@@ -3603,6 +3794,6 @@
     IMPLICIT NONE
 
-    INTEGER(iwp)           ::  ierr   !:
-    INTEGER(iwp)           ::  istat  !:
+    INTEGER(iwp)           ::  ierr   !<
+    INTEGER(iwp)           ::  istat  !<
 
     CHARACTER(LEN=*), INTENT(IN) ::  local_nesting_mode
@@ -3651,17 +3842,17 @@
     IMPLICIT NONE
 
-    INTEGER(iwp), INTENT(IN) ::  direction   !:
+    INTEGER(iwp), INTENT(IN) ::  direction   !<
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  child_id    !:
-    INTEGER(iwp) ::  i           !:
-    INTEGER(iwp) ::  ierr        !:
-    INTEGER(iwp) ::  j           !:
-    INTEGER(iwp) ::  k           !:
-    INTEGER(iwp) ::  m           !:
-
-    REAL(wp)               ::  waittime    !:
-    REAL(wp), DIMENSION(1) ::  dtc         !:
-    REAL(wp), DIMENSION(1) ::  dtl         !:
+    INTEGER(iwp) ::  child_id    !<
+    INTEGER(iwp) ::  i           !<
+    INTEGER(iwp) ::  ierr        !<
+    INTEGER(iwp) ::  j           !<
+    INTEGER(iwp) ::  k           !<
+    INTEGER(iwp) ::  m           !<
+
+    REAL(wp)               ::  waittime    !<
+    REAL(wp), DIMENSION(1) ::  dtc         !<
+    REAL(wp), DIMENSION(1) ::  dtl         !<
 
 
@@ -3722,15 +3913,15 @@
     IMPLICIT NONE
 
-    INTEGER(iwp), INTENT(IN) ::  direction   !:
+    INTEGER(iwp), INTENT(IN) ::  direction   !<
 
 #if defined( __parallel )
-    INTEGER(iwp) ::  ierr        !:
-    INTEGER(iwp) ::  icl         !:
-    INTEGER(iwp) ::  icr         !:
-    INTEGER(iwp) ::  jcs         !:
-    INTEGER(iwp) ::  jcn         !:
+    INTEGER(iwp) ::  ierr        !<
+    INTEGER(iwp) ::  icl         !<
+    INTEGER(iwp) ::  icr         !<
+    INTEGER(iwp) ::  jcs         !<
+    INTEGER(iwp) ::  jcn         !<
     
-    REAL(wp), DIMENSION(1) ::  dtl         !:
-    REAL(wp), DIMENSION(1) ::  dts         !:
+    REAL(wp), DIMENSION(1) ::  dtl         !<
+    REAL(wp), DIMENSION(1) ::  dts         !<
 
 
@@ -3788,28 +3979,28 @@
 !--       Left border pe:
           IF ( nest_bound_l )  THEN
-             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
-                                       r1yo, r2yo, r1zo, r2zo,                  &
-                                       logc_u_l, logc_ratio_u_l,                &
+             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
+                                       r1yo, r2yo, r1zo, r2zo,                 &
+                                       logc_u_l, logc_ratio_u_l,               &
                                        nzt_topo_nestbc_l, 'l', 'u' )
 
-             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
-                                       r1yv, r2yv, r1zo, r2zo,                  &
-                                       logc_v_l, logc_ratio_v_l,                &
+             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
+                                       r1yv, r2yv, r1zo, r2zo,                 &
+                                       logc_v_l, logc_ratio_v_l,               &
                                        nzt_topo_nestbc_l, 'l', 'v' )
 
-             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
-                                       r1yo, r2yo, r1zw, r2zw,                  &
-                                       logc_w_l, logc_ratio_w_l,                &
+             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
+                                       r1yo, r2yo, r1zw, r2zw,                 &
+                                       logc_w_l, logc_ratio_w_l,               &
                                        nzt_topo_nestbc_l, 'l', 'w' )
 
-             CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
-                                       r1yo, r2yo, r1zo, r2zo,                  &
-                                       logc_u_l, logc_ratio_u_l,                &
+             CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,     &
+                                       r1yo, r2yo, r1zo, r2zo,                 &
+                                       logc_u_l, logc_ratio_u_l,               &
                                        nzt_topo_nestbc_l, 'l', 'e' )
 
              IF ( .NOT. neutral )  THEN
-                CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,   &
-                                          r1yo, r2yo, r1zo, r2zo,               &
-                                          logc_u_l, logc_ratio_u_l,             &
+                CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
+                                          r1yo, r2yo, r1zo, r2zo,              &
+                                          logc_u_l, logc_ratio_u_l,            &
                                           nzt_topo_nestbc_l, 'l', 's' )
              ENDIF
@@ -3817,7 +4008,7 @@
              IF ( humidity )  THEN
 
-                CALL pmci_interp_tril_lr( q, q_c, ico, jco, kco, r1xo, r2xo,    &
-                                          r1yo, r2yo, r1zo, r2zo,               &
-                                          logc_u_l, logc_ratio_u_l,             &
+                CALL pmci_interp_tril_lr( q, q_c, ico, jco, kco, r1xo, r2xo,   &
+                                          r1yo, r2yo, r1zo, r2zo,              &
+                                          logc_u_l, logc_ratio_u_l,            &
                                           nzt_topo_nestbc_l, 'l', 's' )
 
@@ -3853,7 +4044,7 @@
 
              IF ( passive_scalar )  THEN
-                CALL pmci_interp_tril_lr( s, sc, ico, jco, kco, r1xo, r2xo,     &
-                                          r1yo, r2yo, r1zo, r2zo,               &
-                                          logc_u_l, logc_ratio_u_l,             &
+                CALL pmci_interp_tril_lr( s, sc, ico, jco, kco, r1xo, r2xo,    &
+                                          r1yo, r2yo, r1zo, r2zo,              &
+                                          logc_u_l, logc_ratio_u_l,            &
                                           nzt_topo_nestbc_l, 'l', 's' )
              ENDIF
@@ -3916,29 +4107,29 @@
 !--       Right border pe
           IF ( nest_bound_r )  THEN
-             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,      &
-                                       r1yo, r2yo, r1zo, r2zo,                  &
-                                       logc_u_r, logc_ratio_u_r,                &
+             CALL pmci_interp_tril_lr( u,  uc,  icu, jco, kco, r1xu, r2xu,     &
+                                       r1yo, r2yo, r1zo, r2zo,                 &
+                                       logc_u_r, logc_ratio_u_r,               &
                                        nzt_topo_nestbc_r, 'r', 'u' )
 
-             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,      &
-                                       r1yv, r2yv, r1zo, r2zo,                  &
-                                       logc_v_r, logc_ratio_v_r,                &
+             CALL pmci_interp_tril_lr( v,  vc,  ico, jcv, kco, r1xo, r2xo,     &
+                                       r1yv, r2yv, r1zo, r2zo,                 &
+                                       logc_v_r, logc_ratio_v_r,               &
                                        nzt_topo_nestbc_r, 'r', 'v' )
 
-             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,      &
-                                       r1yo, r2yo, r1zw, r2zw,                  &
-                                       logc_w_r, logc_ratio_w_r,                &
+             CALL pmci_interp_tril_lr( w,  wc,  ico, jco, kcw, r1xo, r2xo,     &
+                                       r1yo, r2yo, r1zw, r2zw,                 &
+                                       logc_w_r, logc_ratio_w_r,               &
                                        nzt_topo_nestbc_r, 'r', 'w' )
 
-             CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,      &
-                                       r1yo,r2yo, r1zo, r2zo,                   &
-                                       logc_u_r, logc_ratio_u_r,                &
+             CALL pmci_interp_tril_lr( e,  ec,  ico, jco, kco, r1xo, r2xo,     &
+                                       r1yo,r2yo, r1zo, r2zo,                  &
+                                       logc_u_r, logc_ratio_u_r,               &
                                        nzt_topo_nestbc_r, 'r', 'e' )
 
 
              IF ( .NOT. neutral )  THEN
-                CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,   &
-                                          r1yo, r2yo, r1zo, r2zo,               &
-                                          logc_u_r, logc_ratio_u_r,             &
+                CALL pmci_interp_tril_lr( pt, ptc, ico, jco, kco, r1xo, r2xo,  &
+                                          r1yo, r2yo, r1zo, r2zo,              &
+                                          logc_u_r, logc_ratio_u_r,            &
                                           nzt_topo_nestbc_r, 'r', 's' )
 
@@ -3946,7 +4137,7 @@
 
              IF ( humidity )  THEN
-                CALL pmci_interp_tril_lr( q, q_c, ico, jco, kco, r1xo, r2xo,    &
-                                          r1yo, r2yo, r1zo, r2zo,               &
-                                          logc_u_r, logc_ratio_u_r,             &
+                CALL pmci_interp_tril_lr( q, q_c, ico, jco, kco, r1xo, r2xo,   &
+                                          r1yo, r2yo, r1zo, r2zo,              &
+                                          logc_u_r, logc_ratio_u_r,            &
                                           nzt_topo_nestbc_r, 'r', 's' )
 
